package com.docus.server.service.impl;

import com.docus.infrastructure.core.db.dao.IBaseDao;
import com.docus.infrastructure.redis.service.IdService;
import com.docus.infrastructure.web.request.SearchDTO;
import com.docus.infrastructure.web.response.PageResult;
import com.docus.server.convert.RcvSysParamConvert;
import com.docus.server.dto.recovery.rcvsysparam.AddRcvSysParamDTO;
import com.docus.server.dto.recovery.rcvsysparam.DeleteRcvSysParamDTO;
import com.docus.server.dto.recovery.rcvsysparam.EditRcvSysParamDTO;
import com.docus.server.entity.recovery.RcvSysParam;
import com.docus.server.infrastructure.dao.IRcvSysParamDao;
import com.docus.server.service.IRcvSysParamService;
import com.docus.server.vo.recovery.rcvsysparam.RcvSysParamVO;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.io.Serializable;
import java.util.Collection;
import java.util.List;

/**
 * 系统参数表 服务实现类
 *
 * @author AutoGenerator
 * @since 2023-09-13
 */
@Service
public class RcvSysParamServiceImpl implements IRcvSysParamService {
    @Resource
    private IRcvSysParamDao iRcvSysParamDao;
    @Resource
    private IdService idService;

    /**
     * 按主键查询
     *
     * @param id 主键Id
     * @return 实体
     */
    @Override
    public RcvSysParamVO findById(Serializable id) {
        return RcvSysParamConvert.INSTANCE.convertVO(iRcvSysParamDao.findById(id));
    }

    /**
     * 按主键集合查询
     *
     * @param ids 主键ids
     * @return 实体列表
     */
    @Override
    public List<RcvSysParamVO> findByIds(List<Serializable> ids) {
        return RcvSysParamConvert.INSTANCE.convertVO(iRcvSysParamDao.findByIds(ids));
    }

    /**
     * 按属性查询
     *
     * @param propertyName  属性名
     * @param propertyValue 属性值
     * @return 实体列表
     */
    @Override
    public List<RcvSysParamVO> findBy(String propertyName, Object propertyValue) {
        return RcvSysParamConvert.INSTANCE.convertVO(iRcvSysParamDao.findBy(propertyName, propertyValue));
    }

    /**
     * 按属性查询
     *
     * @param propertyName  属性名
     * @param propertyValue 属性值
     * @return 实体列表
     */
    @Override
    public List<RcvSysParamVO> findBy(String propertyName, Collection<?> propertyValue) {
        return RcvSysParamConvert.INSTANCE.convertVO(iRcvSysParamDao.findBy(propertyName, propertyValue));
    }

    /**
     * 按属性查询
     *
     * @param propertyName  属性名
     * @param propertyValue 属性值
     * @return 实体
     */
    @Override
    public RcvSysParamVO findOneBy(String propertyName, Object propertyValue) {
        return RcvSysParamConvert.INSTANCE.convertVO(iRcvSysParamDao.findOneBy(propertyName, propertyValue));
    }

    /**
     * 按属性查询
     *
     * @param propertyName  属性名
     * @param propertyValue 属性值
     * @return 实体
     */
    @Override
    public RcvSysParamVO findOneBy(String propertyName, Collection<?> propertyValue) {
        return RcvSysParamConvert.INSTANCE.convertVO(iRcvSysParamDao.findOneBy(propertyName, propertyValue));
    }

    /**
     * 查询所有
     *
     * @return 实体列表
     */
    @Override
    public List<RcvSysParamVO> findAll() {
        return RcvSysParamConvert.INSTANCE.convertVO(iRcvSysParamDao.findAll());
    }

    /**
     * 关键字搜索
     *
     * @param searchDTO 搜索参数
     * @return 分页列表
     */
    @Override
    public PageResult<RcvSysParamVO> search(SearchDTO searchDTO) {
        return RcvSysParamConvert.INSTANCE.convertVO(iRcvSysParamDao.search(searchDTO));

        //PageResult<RcvSysParamVO> result = RcvSysParamConvert.INSTANCE.convertVO(iRcvSysParamDao.search(searchDTO));

        //if (CollectionUtils.isEmpty(result.getList())) {
        //return new PageResult<>();
        //}

        //Map<String, SchSystemParams> map = iSchSystemParamsService.find(ListUtils.distinctSelect(result.getList(), SchCollectorVO::getCollectorId));

        //result.getList().forEach(p -> {
        // String collectorId = String.valueOf(p.getCollectorId());
        // if (map.containsKey(collectorId)) {
        //     p.setCollectorName(map.get(collectorId).getParamName());
        // }
        //});

        //return result;
    }

    /**
     * 新增
     *
     * @param addRcvSysParamDTO 编辑参数
     * @return 成功或失败
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean add(AddRcvSysParamDTO addRcvSysParamDTO) {
        RcvSysParam rcvSysParam = RcvSysParamConvert.INSTANCE.convertDO(addRcvSysParamDTO);
        rcvSysParam.setId(idService.getDateSeq());
        return iRcvSysParamDao.add(rcvSysParam);

        // String name = addRcvSysParamDTO.getName();

        //RcvSysParam rcvSysParam = iRcvSysParamDao.findOneBy("name", name);

        //if (Func.notNull(rcvSysParam)) {
        // throw new ApiException(ExceptionCode.ParamIllegal.getCode(), "系统参数表已经存在");
        // }

        // RcvSysParam rcvSysParam =RcvSysParamConvert.INSTANCE.convertDO(addRcvSysParamDTO);
        // rcvSysParam.setId(idService.getDateSeq());

        // return iRcvSysParamDao.add(schCollector);

    }

    /**
     * 批量新增
     *
     * @param addRcvSysParamDTOList 编辑参数
     * @return 成功或失败
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean addBatch(List<AddRcvSysParamDTO> addRcvSysParamDTOList) {

        List<RcvSysParam> rcvSysParamList = RcvSysParamConvert.INSTANCE.convertAddDOList(addRcvSysParamDTOList);

        rcvSysParamList.forEach(p -> {
            p.setId(idService.getDateSeq());
        });

        return iRcvSysParamDao.saveBatch(rcvSysParamList, IBaseDao.DEFAULT_BATCH_SIZE);
    }

    /**
     * 新增或编辑
     *
     * @param editRcvSysParamDTO 新增或编辑参数
     * @return 成功或失败
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean addOrEdit(EditRcvSysParamDTO editRcvSysParamDTO) {
        RcvSysParam rcvSysParam = RcvSysParamConvert.INSTANCE.convertDO(editRcvSysParamDTO);
        return iRcvSysParamDao.saveOrUpdate(rcvSysParam);
    }

    /**
     * 批量新增或编辑
     *
     * @param editRcvSysParamDTOList 新增或编辑参数
     * @return 成功或失败
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean addOrEditBatch(List<EditRcvSysParamDTO> editRcvSysParamDTOList) {
        List<RcvSysParam> rcvSysParamList = RcvSysParamConvert.INSTANCE.convertEditDOList(editRcvSysParamDTOList);
        return iRcvSysParamDao.saveOrUpdateBatch(rcvSysParamList, IBaseDao.DEFAULT_BATCH_SIZE);
    }

    /**
     * 编辑
     *
     * @param editRcvSysParamDTO 编辑参数
     * @return 成功或失败
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean edit(EditRcvSysParamDTO editRcvSysParamDTO) {
        RcvSysParam rcvSysParam = RcvSysParamConvert.INSTANCE.convertDO(editRcvSysParamDTO);
        return iRcvSysParamDao.edit(rcvSysParam);

        // Long id = editRcvSysParamDTO.getId();

        //  RcvSysParam rcvSysParam = iRcvSysParamDao.findById(id);

        // if (Func.isNull(rcvSysParam)) {
        //     throw new ApiException(ExceptionCode.ParamIllegal.getCode(), "系统参数表，无法更新！");
        // }

        // rcvSysParam.setUpdateTime(LocalDateTime.now());
        // return iRcvSysParamDao.edit(rcvSysParam);
    }

    /**
     * 批量编辑
     *
     * @param editRcvSysParamDTOList 编辑参数
     * @return 成功或失败
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean editBatchById(List<EditRcvSysParamDTO> editRcvSysParamDTOList) {
        List<RcvSysParam> rcvSysParamList = RcvSysParamConvert.INSTANCE.convertEditDOList(editRcvSysParamDTOList);
        return iRcvSysParamDao.updateBatchById(rcvSysParamList, IBaseDao.DEFAULT_BATCH_SIZE);
    }

    /**
     * 批量删除
     *
     * @param deleteRcvSysParamDTO 删除参数
     * @return 成功或失败
     */
    @Override
    public int delete(DeleteRcvSysParamDTO deleteRcvSysParamDTO) {
        return iRcvSysParamDao.delete(deleteRcvSysParamDTO.getIds());
    }

    /**
     * 按主键删除
     *
     * @param id 删除参数
     * @return 成功或失败
     */
    @Override
    public int delete(Serializable id) {
        return iRcvSysParamDao.delete(id);
    }

    /**
     * 按属性删除
     *
     * @param propertyName  删除属性名
     * @param propertyValue 删除属性值
     * @return 成功或失败
     */
    @Override
    public int deleteBy(String propertyName, Object propertyValue) {
        return iRcvSysParamDao.deleteBy(propertyName, propertyValue);
    }

    /**
     * 按属性删除
     *
     * @param propertyName  删除属性名
     * @param propertyValue 删除属性值集合
     * @return 成功或失败
     */
    @Override
    public int deleteBy(String propertyName, Collection<?> propertyValue) {
        return iRcvSysParamDao.deleteBy(propertyName, propertyValue);
    }

    /**
     * 按主键集合批量删除
     *
     * @param ids 删除参数
     * @return 成功或失败
     */
    @Override
    public int deleteByIds(Collection<? extends Serializable> ids) {
        return iRcvSysParamDao.deleteByIds(ids);
    }

    /**
     * 名称不重复
     *
     * @param id   主键
     * @param name 名称
     * @return 名称重复数量
     */
    @Override
    public int findByIdAndName(Serializable id, String name) {
        return iRcvSysParamDao.findByIdAndName(id, name);
    }

}

